from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Directory, String

Rgt_Tdf_Regiontest_V0_1_0 = CommandToolBuilder(tool="rgt_TDF_regiontest", base_command=["rgt-TDF", "regiontest"], inputs=[ToolInput(tag="in_input_file_name", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="Input file name for RNA sequence (in fasta format)")), ToolInput(tag="in_rl", input_type=Boolean(optional=True), prefix="-rl", doc=InputDocumentation(doc="Input list for paths to all RNA sequences (in fasta format)")), ToolInput(tag="in_rn", input_type=Boolean(optional=True), prefix="-rn", doc=InputDocumentation(doc="Define the RNA name")), ToolInput(tag="in_bed", input_type=Boolean(optional=True), prefix="-bed", doc=InputDocumentation(doc="Input BED file for interested regions on DNA")), ToolInput(tag="in_output_directory_name", input_type=Directory(optional=True), prefix="-o", doc=InputDocumentation(doc="Output directory name for all the results and temporary files")), ToolInput(tag="in_define_title_name", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="Define the title name for the results under the Output name.\n(default is RNA name)")), ToolInput(tag="in_number_times_randomization", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="Number of times for randomization (default: 10000)")), ToolInput(tag="in_organism", input_type=Boolean(optional=True), prefix="-organism", doc=InputDocumentation(doc="Define the organism")), ToolInput(tag="in_show_dbs", input_type=Boolean(optional=True), prefix="-showdbs", doc=InputDocumentation(doc="Show the plots and statistics of DBS (DNA Binding sites)")), ToolInput(tag="in_score", input_type=Boolean(optional=True), prefix="-score", doc=InputDocumentation(doc="Load score column from input BED file")), ToolInput(tag="in_define_significance_level", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="Define significance level for rejection null hypothesis\n(default: 0.05)")), ToolInput(tag="in_ccf", input_type=Boolean(optional=True), prefix="-ccf", doc=InputDocumentation(doc="Define the cut off of triplex-forming regions per DBD in\npercentage of total triplexes (0-1) or an integer. (default:\n0.1)")), ToolInput(tag="in_rt", input_type=Boolean(optional=True), prefix="-rt", doc=InputDocumentation(doc="Remove temporary files (fa, txp...etc)")), ToolInput(tag="in_log", input_type=Boolean(optional=True), prefix="-log", doc=InputDocumentation(doc="Set the plots in log scale")), ToolInput(tag="in_input_bed_file_mask", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="Input BED file as mask in randomization")), ToolInput(tag="in_obed", input_type=Boolean(optional=True), prefix="-obed", doc=InputDocumentation(doc="Output the BED files for DNA binding sites.")), ToolInput(tag="in_show_pa", input_type=Boolean(optional=True), prefix="-showpa", doc=InputDocumentation(doc="Show parallel and antiparallel bindings in the plot")), ToolInput(tag="in_no_file", input_type=Directory(optional=True), prefix="-nofile", doc=InputDocumentation(doc="Don't save any files in the output folder, except the")), ToolInput(tag="in_set_maximal_errorrate", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="[Triplexes] Set the maximal error-rate in % tolerated\n(default: 20)")), ToolInput(tag="in_sets_tolerated_number", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="[Triplexes] Sets the tolerated number of consecutive errors\nwith respect to the canonical triplex rules as such were found\nto greatly destabilize triplexes in vitro (default: 2)")), ToolInput(tag="in_fr", input_type=Boolean(optional=True), prefix="-fr", doc=InputDocumentation(doc="[Triplexes] Activates the filtering of low complexity regions\nand repeats in the sequence data (default: off)")), ToolInput(tag="in_fm", input_type=Boolean(optional=True), prefix="-fm", doc=InputDocumentation(doc="[Triplexes] Method to quickly discard non-hits (default:\n0).'0' = greedy approach; '1' = q-gram filtering.")), ToolInput(tag="in_of", input_type=Boolean(optional=True), prefix="-of", doc=InputDocumentation(doc="[Triplexes] Define output formats of Triplexes (default: 1)")), ToolInput(tag="in_mf", input_type=Boolean(optional=True), prefix="-mf", doc=InputDocumentation(doc="[Triplexes] Merge overlapping features into a cluster and\nreport the spanning region.")), ToolInput(tag="in_rm", input_type=Boolean(optional=True), prefix="-rm", doc=InputDocumentation(doc="[Triplexes] Set the multiprocessing")), ToolInput(tag="in_par", input_type=Boolean(optional=True), prefix="-par", doc=InputDocumentation(doc="[Triplexes] Define other parameters for Triplexes")), ToolInput(tag="in_separately_dot", input_type=String(), position=0, doc=InputDocumentation(doc="-mp           Define the number of threads for multiprocessing")), ToolInput(tag="in_statistics_dot", input_type=String(), position=1, doc=InputDocumentation(doc="-l            [Triplexes] Define the minimum length of triplex (default: 20)"))], outputs=[ToolOutput(tag="out_output_directory_name", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_output_directory_name", type_hint=File()), doc=OutputDocumentation(doc="Output directory name for all the results and temporary files")), ToolOutput(tag="out_no_file", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_no_file", type_hint=File()), doc=OutputDocumentation(doc="Don't save any files in the output folder, except the"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Rgt_Tdf_Regiontest_V0_1_0().translate("wdl", allow_empty_container=True)

